#include "../res/shader_settings.hlsli"
//Textures
Texture2DMS<float4, SAMPLE_COUNT> gBufferTexture : register(t0);

float4 main(in float4 screenPos : SV_Position) : SV_Target0
{
	//sample the mask from the g-buffer
	int2 sampleIndices = int2(screenPos.xy);
	float mask = 0.0f;

	for (uint i = 0; i < SAMPLE_COUNT; ++i)
		mask += gBufferTexture.Load(sampleIndices, i).z;

	if (mask == 0.0f)
		clip(-1.0f);

	return 0.0f;
}