cbuffer GradientBuffer
{
	float4 apexColor;
	float4 centerColor;
};

struct PSInput
{
	float4 postion : SV_POSITION;
	float4 modelPosition : TEXCOORD0;
};

float4 main(PSInput input) : SV_TARGET
{
	float height;
	float4 outColor;

	// determine the position on the sky sphere where the pixel is located
	height = input.modelPosition.y;

	// values range from -1.0f to +1.0f so change to only position
	height = clamp(abs(height), 0, 1);

	// determine the gradient color by lerping between apex and center
	outColor = lerp(centerColor, apexColor, height);

	return outColor;
}