cbuffer Transforms
{
	matrix worldMatrix;
	matrix viewMatrix;
	matrix projectionMatrix;
};

struct VSInput
{
	float4 position : POSITION;
	float2 texCoord : TEXCOORD0;
	float3 normal : NORMAL;
	float4 tangent : TANGENT;
};

struct PSInput
{
	float4 position : SV_POSITION;
	float4 modelPosition : TEXCOORD0;
};

PSInput main( VSInput input )
{
	PSInput output;

	// Calculate clip space position of the vertex
	input.position.w = 1.0f;
	output.position = mul(input.position, worldMatrix);
	output.position = mul(output.position, viewMatrix);
	output.position = mul(output.position, projectionMatrix);

	// send model position to the pixel shader
	output.modelPosition = input.position;

	return output;
}