#ifndef _BASEDEFERREDSHADER_H_
#define _BASEDEFERREDSHADER_H_


#include "D3D.h"

#include <d3d11.h>
#include <D3Dcompiler.h>
#include <dxgi.h>
#include <DirectXMath.h>
#include <fstream>

using namespace std;
using namespace DirectX;

class BaseDeferredShader
{
public:
	BaseDeferredShader(ID3D11Device* device, HWND hwnd);
	~BaseDeferredShader();

	virtual void Render(ID3D11DeviceContext* deviceContext, int vertexCount);

protected:
	virtual void InitShader(WCHAR* vsFilename, WCHAR* psFilename) = 0; 
	void OutputShaderErrorMessage(ID3D10Blob*, HWND, WCHAR*);
	void loadVertexShader(WCHAR* filename, LPCSTR entrypoint = "main");
	void loadPixelShader(WCHAR* filename, LPCSTR entrypoint = "main");

protected:
	ID3D11Device* m_device;
	HWND m_hwnd;

	ID3D11SamplerState* m_sampleState;
	ID3D11InputLayout* m_layout;
	ID3D11VertexShader* m_vertexShader;
	ID3D11PixelShader* m_pixelShader;
};

#endif