#ifndef _BASEGBUFFERSHADER_H_
#define _BASEGBUFFERSHADER_H_

#include "D3D.h"

#include <d3d11.h>
#include <D3Dcompiler.h>
#include <dxgi.h>
#include <DirectXMath.h>
#include <fstream>


using namespace std;
using namespace DirectX;

class BaseGBufferShader
{
protected:
	struct MatrixBufferType
	{
		XMMATRIX world;
		XMMATRIX view;
		XMMATRIX projection;
	};

public:

	BaseGBufferShader(ID3D11Device* device, HWND hwnd);
	~BaseGBufferShader();

	virtual void Render(ID3D11DeviceContext* deviceContext, int vertexCount);

protected:
	virtual void InitShader(WCHAR*, WCHAR*) = 0;
	void OutputShaderErrorMessage(ID3D10Blob*, HWND, WCHAR*);
	void loadVertexShader(WCHAR*, LPCSTR entrypoint = "main");
	void loadPixelShader(WCHAR*, LPCSTR entrypoint = "main");
	void loadHullShader(WCHAR*, LPCSTR entrypoint = "main");
	void loadDomainShader(WCHAR*, LPCSTR entrypoint = "main");
	void loadGeometryShader(WCHAR*, LPCSTR entrypoint = "main");

protected:
	ID3D11Device* m_device;
	HWND m_hwnd;

	ID3D11Buffer* m_matrixBuffer;
	ID3D11SamplerState* m_sampleState;
	ID3D11InputLayout* m_layout;
	ID3D11VertexShader* m_vertexShader;
	ID3D11PixelShader* m_pixelShader;
	ID3D11HullShader* m_hullShader;
	ID3D11DomainShader* m_domainShader;
	ID3D11GeometryShader* m_geometryShader;

	bool m_boneAnimating = false;
};
#endif