#include "BaseScene.h"

ResourceContainer *ResourceContainer::m_containerInstance = 0;

BaseScene::BaseScene(D3D* d3d, HWND hwnd, int screenWidth, int screenHeight)
{
	m_deviceContext = d3d->GetDeviceContext();
	m_device = d3d->GetDevice();
	m_Direct3D = d3d;
	m_hwnd = hwnd;
	m_resourceContainer = ResourceContainer::instance();
}

BaseScene::BaseScene(BaseScene& copy)
{
}

BaseScene::~BaseScene()
{
	m_resourceContainer->ClearResources();
	for (auto object : m_objects)
	{
		delete object;
	}
	m_objects.clear();
}

SceneObject* BaseScene::GetObjectByName(const std::wstring& name)
{
	for (auto object : m_objects)
	{
		if (object->GetName() == name)
			return object;
	}
}