#ifndef _SCENE_H_
#define _SCENE_H_

#include "ResourceContainer.h"
#include "SceneObject.h"
#include "Input.h"

class BaseScene
{
public:
	BaseScene(D3D* d3d, HWND hwnd, int screenWidth, int screenHeight);
	BaseScene(BaseScene& copy);
	~BaseScene();

	virtual void Update(Input* input, float frameTime) = 0;
	virtual void Render() = 0;

	SceneObject* GetObjectByName(const std::wstring& name);

protected:
	virtual void HandleInput(Input* input, float frameTime) = 0;

protected:
	ResourceContainer* m_resourceContainer;
	std::vector<SceneObject*> m_objects;

	D3D* m_Direct3D;
	ID3D11DeviceContext* m_deviceContext;
	ID3D11Device* m_device;
	HWND m_hwnd;
};
#endif