#ifndef _DEFERREDBUFFERS_H_
#define _DEFERREDBUFFERS_H_

#include "D3D.h"


class DeferredBuffers
{
public:
	DeferredBuffers(ID3D11Device* device, ID3D11DeviceContext* deviceContext, int screenWidth, int screenHeight, int bufferCount, int subsamples);
	~DeferredBuffers();

	void SetRenderTargets(ID3D11DepthStencilView* stencilView = NULL);
	void ClearRenderTargets(float r, float g, float b, float a);

	ID3D11ShaderResourceView* GetShaderResourceView(int bufferNum);
	ID3D11DepthStencilView* GetDepthStencilView();

private:
	void InitGBuffer(int screenWidth, int screenHeight);
private:	
	int m_screenWidth, m_screenHeight;
	int m_gBufferCount;
	int m_sampleCount;
	ID3D11Device* m_device;
	ID3D11DeviceContext* m_deviceContext;
	ID3D11RenderTargetView** m_gBufferTargetView;
	ID3D11Texture2D** m_gBufferRenderTexture;
	ID3D11ShaderResourceView** m_gBufferResourceView;
	ID3D11Texture2D* m_depthStencilBuffer;
	ID3D11DepthStencilView* m_depthStencilView;
	D3D11_VIEWPORT m_viewport;
};

#endif