#ifndef _AMBIENTOCCLUSIONSHADER_H_
#define _AMBIENTOCCLUSIONSHADER_H_

#include <ctime>

#include "../DXFramework/BaseShader.h"
#include "math_utils.h"

class AmbientOcclusionShader : public BaseShader
{
protected:
	struct VSFrustumDataBufferType
	{
		XMFLOAT4 frustumCorners[4];
	};

	struct PSOcclusionDataBufferType
	{
		XMFLOAT4 resolution;
		XMFLOAT4 perspective;
		XMFLOAT4 frustum;
		XMFLOAT4 offsetVectors[14];
	};

	struct PSOcclusionFactorsBufferType
	{
		float occlusionRadius;
		float occlusionFadeStart;
		float occlusionFadeEnd;
		float occlusionSurfaceEpsilon;
	};

public:
	AmbientOcclusionShader(ID3D11Device* device, HWND hwnd);
	~AmbientOcclusionShader();

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

protected:
	void InitShader(WCHAR*, WCHAR*);

protected:
	ID3D11Buffer* m_psOcclusionDataBuffer;
	ID3D11Buffer* m_psOcclusionFactorsBuffer;
	ID3D11Buffer* m_vsFrustumDataBuffer;
	XMFLOAT4 m_offsets[14];
	ID3D11SamplerState* m_depthSampler;
	ID3D11SamplerState* m_randomMapSampler;
};

#endif