// Lab1.cpp
// Lab 1 example, simple coloured triangle mesh
#include "App.h"
#include "../res/shader_settings.hlsli"

App::App()
{
	m_scene = 0;
}

void App::init(HINSTANCE hinstance, HWND hwnd, int screenWidth, int screenHeight, Input *in)
{
	// Call super init function (required!)
	BaseApplication::init(hinstance, hwnd, screenWidth, screenHeight, in);

	// Initialize the test scene
	m_scene = new TestScene(m_Direct3D, hwnd, screenWidth, screenHeight);
}


App::~App()
{
	// Run base application deconstructor
	BaseApplication::~BaseApplication();

	if (m_scene)
	{
		delete m_scene;
		m_scene = 0;
	}
}


bool App::Frame()
{
	bool result;

	result = BaseApplication::Frame();
	if (!result)
	{
		return false;
	}

	m_scene->Update(m_Input, m_Timer->GetTime());

	return true;
}

bool App::Render()
{
	return true;
}


