#ifndef _BILATERALBLURSHADER_H_
#define _BILATERALBLURSHADER_H_

#include "../DXFramework/BaseShader.h"

class BilateralBlurShader : public BaseShader
{
protected:
	struct PSPerFrameBufferType
	{
		float texelWidth;
		float texelHeight;
		float horizontalBlur;
		float padding;
	};


public:
	BilateralBlurShader(ID3D11Device* device, HWND hwnd);
	~BilateralBlurShader();

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

protected:
	void InitShader(WCHAR* vsFilename, WCHAR* psFilename);

protected:
	ID3D11Buffer* m_psPerFrameBuffer;
	ID3D11SamplerState* m_normalDepthSampler;
	ID3D11SamplerState* m_imageSampler;
};
#endif