#ifndef _COMPUTEAMBIENTOCCLUSIONSHADER_H_
#define _COMPUTEAMBIENTOCCLUSIONSHADER_H_

#include "../DXFramework/BaseShader.h"

class ComputeAmbientOcclusionShader : public BaseShader
{
protected:
	struct CSOcclusionDataBufferType
	{
		XMFLOAT4 resolution;
		XMFLOAT4 perspective;
		XMFLOAT4 frustum;
	};

	struct CSOcclusionFactorsBufferType
	{
		float occlusionSurfaceEpsilon;
		float occlusionFadeStart;
		float occlusionFadeEnd;
		float occlusionRadius;
	};

public:
	ComputeAmbientOcclusionShader(ID3D11Device* device, HWND hwnd);
	~ComputeAmbientOcclusionShader();

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

protected:
	void InitShader(WCHAR*, WCHAR*);

protected:
	ID3D11Buffer* m_csOcclusionDataBuffer;
	ID3D11Buffer* m_csOcclusionFactorsBuffer;
};

#endif