#ifndef _DEFERREDGBUFFERSHADER_H_
#define _DEFERREDGBUFFERSHADER_H_

#include "../DXFramework/BaseShader.h"

class DeferredGBufferShader : public BaseShader
{
private:
	struct MaterialBufferType
	{
		XMFLOAT3 specularAlbedo;
		float specularPower;
	};

public:

	DeferredGBufferShader(ID3D11Device* device, HWND hwnd);
	~DeferredGBufferShader();

	void SetShaderParameters(ID3D11DeviceContext* deviceContext, const XMMATRIX &world, const XMMATRIX &view, const XMMATRIX &projection, ID3D11ShaderResourceView* texture, ID3D11ShaderResourceView* normalMap);
	void Render(ID3D11DeviceContext* deviceContext, int vertexCount);

private:
	void InitShader(WCHAR*, WCHAR*);

private:
	ID3D11Buffer* m_materialBuffer;
};
#endif