#ifndef _DEFERREDSHADER_H_
#define _DEFERREDSHADER_H_

#include "../DXFramework/BaseShader.h"
#include "../DXFramework/Light.h"



class DeferredShader : public BaseShader
{
private:
	struct LightBufferType
	{
		XMFLOAT4 lightPos;
		XMFLOAT4 lightColor;
		XMFLOAT4 lightDirection;
		XMFLOAT4 lightRange;
		XMFLOAT2 spotlightAngles;
		float lightType;
		float padding;
	};

	struct CameraBufferType
	{
		XMFLOAT3 cameraPos;
		float padding;
	};
	
	public:

		DeferredShader(ID3D11Device* device, HWND hwnd);
		~DeferredShader();

		void SetShaderParameters(ID3D11DeviceContext* deviceContext, ID3D11ShaderResourceView* normalTexture, ID3D11ShaderResourceView* diffuseTexture, ID3D11ShaderResourceView* specularTexture, ID3D11ShaderResourceView* positionTexture, Light* light, const XMFLOAT3 &cameraPos);

		void Render(ID3D11DeviceContext* deviceContext, int vertexCount);


	private:
		void InitShader(WCHAR*, WCHAR*);

	private:
		ID3D11Buffer* m_lightBuffer;
		ID3D11Buffer* m_cameraBuffer;

};
#endif