#ifndef _POINTLIGHTSHADER_H_
#define _POINTLIGHTSHADER_H_


#include "../DXFramework/BaseShader.h"
#include "../DXFramework/Light.h"

using namespace std;
using namespace DirectX;


class PointLightShader : public BaseShader
{
private:
	struct LightBufferType
	{
		XMFLOAT4 ambient_diffuse;
		XMFLOAT4 diffuse[2];
		XMFLOAT3 direction;
		float specularPower;
		XMFLOAT4 specularColor[2];
		XMFLOAT4 pointPosition[2];
		XMFLOAT4 attenuation[2];
	};

	struct CameraBufferType
	{
		XMFLOAT3 cameraPosition;
		float padding;
	};

public:

	PointLightShader(ID3D11Device* device, HWND hwnd);
	~PointLightShader();

	void SetShaderParameters(ID3D11DeviceContext* deviceContext, const XMMATRIX &world, const XMMATRIX &view, const XMMATRIX &projection, ID3D11ShaderResourceView* texture, Light* light1, Light* light2, const XMFLOAT3 &cameraPos);
	void Render(ID3D11DeviceContext* deviceContext, int vertexCount);

private:
	void InitShader(WCHAR*, WCHAR*);

private:
	ID3D11Buffer* m_matrixBuffer;
	ID3D11SamplerState* m_sampleState;
	ID3D11Buffer* m_lightBuffer;
	ID3D11Buffer* m_cameraBuffer;
};

#endif