#ifndef _PREPASSLIGHTSHADER_H_
#define _PREPASSLIGHTSHADER_H_

#include "../DXFramework/BaseShader.h"
#include "../DXFramework/Light.h"

class PrePassLightShader : public BaseShader
{
private:
	struct CameraBufferType
	{
		XMFLOAT3 cameraPos;
		float padding;
	};

	struct MatrixBufferType
	{
		XMMATRIX invViewMatrix;
		XMMATRIX invProjMatrix;
	};

public:
	PrePassLightShader(ID3D11Device* device, HWND hwnd);
	~PrePassLightShader();

	void SetShaderParameters(ID3D11DeviceContext* deviceContext, const XMMATRIX &invViewMatrix, const XMMATRIX &invProjMatrix, ID3D11ShaderResourceView* normalTexture, ID3D11ShaderResourceView* positionTexture, Light* light, const XMFLOAT3 &cameraPos);
	void Render(ID3D11DeviceContext* deviceContext, int vertexCount);


private:
	void InitShader(WCHAR*, WCHAR*);

private:
	ID3D11Buffer* m_lightBuffer;
	ID3D11Buffer* m_cameraBuffer;
	ID3D11Buffer* m_matrixBuffer;
};
#endif