#ifndef _PREPASSLIGHTSHADERMSAA_H_
#define _PREPASSLIGHTSHADERMSAA_H_

#include "../DXFramework/BaseShader.h"
#include "../DXFramework/Light.h"

class PrePassLightShaderMSAA : public BaseShader
{

private:


	struct CameraBufferType
	{
		XMFLOAT3 cameraPos;
		float padding;
	};

	struct MatrixBufferType
	{
		XMMATRIX lightView;
		XMMATRIX lightProj;
	};

public:
	PrePassLightShaderMSAA(ID3D11Device* device, HWND hwnd, bool msaaPass);
	~PrePassLightShaderMSAA();

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

private:
	void InitShader(WCHAR*, WCHAR*);

private:
	bool m_msaaPass;
	ID3D11Buffer* m_lightBuffer;
	ID3D11Buffer* m_cameraBuffer;
	ID3D11Buffer* m_matrixBuffer;
};

#endif
