#ifndef _PREPASSWATERSHADER_H_
#define _PREPASSWATERSHADER_H_

#include "../DXFramework/BaseShader.h"

class  PrePassWaterShader : public BaseShader
{
protected:
	struct CameraBufferType
	{
		XMFLOAT3 cameraPos;
		float padding;
	};

	struct MatrixBufferType
	{
		XMMATRIX lightView;
		XMMATRIX lightProj;
	};

public:
	PrePassWaterShader(ID3D11Device* device, HWND hwnd);
	~PrePassWaterShader();

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

protected:
	void InitShader(WCHAR* vsFilename, WCHAR* psFilename);

protected:
	ID3D11Buffer* m_lightBuffer;
	ID3D11Buffer* m_cameraBuffer;
	ID3D11Buffer* m_matrixBuffer;
};

#endif