#ifndef _SKYBOXSHADER_H_
#define _SKYBOXSHADER_H_

#include "../DXFramework/BaseShader.h"

class SkyboxShader : public BaseShader
{
private:
	// Buffer Structs
	struct VSMatrixBufferType
	{
		XMMATRIX world;
		XMMATRIX view;
		XMMATRIX proj;
	};

	struct PSGradientBufferType
	{
		XMFLOAT4 apexColor;
		XMFLOAT4 centerColor;
	};

public:
	SkyboxShader(ID3D11Device* device, HWND hwnd);
	~SkyboxShader();

	void Render(ID3D11DeviceContext* deviceContext, D3D* d3d, void* resourceContainer);

private:
	void InitShader(WCHAR*, WCHAR*);

private:
	ID3D11Buffer* m_vsMatrixBuffer;
	ID3D11Buffer* m_psGradientBuffer;
};

#endif