#ifndef _TESTSCENE_H_
#define _TESTSCENE_H_

#include "../DXFramework/BaseScene.h"

#include "../DXFramework/Light.h"
#include "../DXFramework/DeferredBuffers.h"
#include "../DXFramework/UnorderedAccessView.h"

#include "PrePassGBufferShader.h"
#include "PrePassMaskShader.h"
#include "PrePassLightShaderMSAA.h"
#include "PrePassFinalShader.h"
#include "TerrainShader.h"
#include "HeightmapProcessShader.h"
#include "DepthShader.h"
#include "AmbientOcclusionShader.h"
#include "BilateralBlurShader.h"
#include "WaterSimulationShader.h"
#include "ShadowMapShader.h"

#include "../DXFramework/QuadMesh.h"
#include "../DXFramework/SphereMesh.h"
#include "../DXFramework/StreamOutputMesh.h"
#include "../DXFramework/Model.h"

#include "TerrainMesh.h"
#include "WaterMesh.h"
#include "math_utils.h"

#include "../DirectXTK/Inc/ScreenGrab.h"

class TestScene : public BaseScene
{
public:
	TestScene(D3D* d3d, HWND hwnd, int screenWidth, int screenHeight);
	~TestScene();

	void Update(Input* input, float frameTime);
	void Render();

protected:
	void HandleInput(Input* input, float frameTime);
	void CaptureGBuffer();
	void InitWaterSimulation();
	void InitTerrainGeneration();
	void InitAmbientOcclusion();

protected:
	float m_runTime, m_frameCount;
};
#endif